/*
	DynAPI Distribution
	DynDocument Class

	The DynAPI Distribution is distributed under the terms of the GNU LGPL license.
	
	requires: dynapi.api.DynElement
*/

function DynDocument(frame) {
	this.inherit('DynElement');
	this.frame = frame;
	this.doc = this.frame.document;
	if (this.frame==dynapi.frame) this.all = DynObject.all;  // need it?
	this._dyndoc = this; // need it?
	this.x = 0;
	this.y = 0;
	this.w = 0;
	this.h = 0;
	this._topZIndex = 10000;
	var o = this;
	this.frame.onresize = function() {o._handleResize()};
	this.onResizeNS4 = "reload" // or "redraw"
	this.fgColor = this.doc.fgColor||'';
	this.bgColor = this.doc.bgColor||'';
	this._created = false;
};
var p = dynapi.setPrototype('DynDocument','DynElement');

p.getBgColor = function() {
	return this.bgColor;
};
p._remove = function() {
	this.elm=null;
	this.doc=null;
	this.frame=null;
};
p.getX = p.getY = p.getPageX = p.getPageY = function() {return 0};
p.getWidth = function() {
	if (!this.w) this.findDimensions();
	return this.w;
};
p.getHeight = function() {
	if (!this.h) this.findDimensions();
	return this.h;
};
p.findDimensions = function() {
	this.w=(dynapi.ua.ns||dynapi.ua.opera)? this.frame.innerWidth : this.elm.clientWidth;
	this.h=(dynapi.ua.ns||dynapi.ua.opera)? this.frame.innerHeight : this.elm.clientHeight;
};
p.setBgColor = function(color) {
	if (color == null) color='';
	if (dynapi.ua.ns4 && color == '') color = '#ffffff';
	this.bgColor = color;
	this.doc.bgColor = color;
};
p.setFgColor = function(color) {
	if (color == null) color='';
	if (dynapi.ua.ns4 && color == '') color='#ffffff';
	this.fgColor = color;
	this.doc.fgColor = color;
};
p.insertChild = function(c) {
	if (c.parent == this) {
		DynElement._flagEvent(c,'precreate');
		this.doc.write(c.getOuterHTML());
		c._inserted = true;
	}
};
p.insertAllChildren = function() {
	var str = '';
	var c;
	for (var i=0;i<this.children.length;i++) {
		c = this.children[i];
		DynElement._flagEvent(c,'precreate');
		str += c.getOuterHTML();
		c._inserted = true;
	}
	this.doc.write(str);
	this.doc.close();
};
p._create = function() {
	this._created = true;
	if (dynapi.ua.ns4) {
		this.css = this.doc;
		this.elm = this.doc;
	}
	else {
		this.elm = this.frame.document.body;
		this.css = this.frame.document.body.style;
		if (dynapi.ua.ie) {
			this._overflow = this.css.overflow || '';
			if (this._cursor) this.css.cursor = this._cursor;
		}
	}
	this.elm.lyrobj = this;
	this.findDimensions();
	for (var i=0;i<this.children.length;i++) {
		if (this.children[i]._inserted) {
			DynLayer._assignElement(this.children[i]);
			DynElement._flagEvent(this.children[i],'create');
		}
		else this.children[i]._create();
	}
	this._updateAnchors();	
	if (this.assignMouseEvents) this.assignMouseEvents();
	this.invokeEvent('load');
};
p._destroy = function() {
	for (var i=0;i<this.children.length;i++) {
		this.children[i]._destroy();
		delete this.children[i];
	}
	delete DynObject.all;
	this.elm = null;
	this.css = null;
	this.frame = null;
};

p._handleResize = function() {
	var w = this.w;
	var h = this.h;
	this.findDimensions();
	if (this.w!=w || this.h!=h) {
		if (dynapi.ua.ns4) {
			if (this.onResizeNS4=="redraw") {
				for (var i=0;i<this.children.length;i++) {
					this.children[i].elm = null;
					if (this.children[i]._created) {
						this.children[i]._created = false;
						this.children[i]._create();
					}
				}
				this.invokeEvent('resize');
			}
			else if (this.onResizeNS4=="reload") {
				this.doc.location.href = this.doc.location.href;
			}
		}
		else this.invokeEvent('resize');
	}
};
p.setCursor = function(c) {
	if (!c) c = 'default';
	if (dynapi.ua.ie && this._cursor!=c) {
		this._cursor = c;
		if (this.css) this.css.cursor = c;
	}
};

function main() {
	if (dynapi.document==null) {
		dynapi.document = new DynDocument(dynapi.frame);
		if (dynapi.loaded) dynapi.document._create();
		else dynapi.onLoad(function() {
			dynapi.document._create();
		});
	}
};
if (!dynapi.loaded) main();