/*
	DynAPI Distribution
	Slide Animation Extension

	The DynAPI Distribution is distributed under the terms of the GNU LGPL license.

	requires: PathAnimation
*/

// To use on a DynLayer:
// dlyr.setMethod("slideTo",PathAnimation.slideTo);  // will overwrite the built in DynLayer.slideTo()
// dlyr.setMethod("slideStop",PathAnimation.slideStop);
// dlyr.slideTo(x,y,5,10);
// dlyr.slideStop();

// Or attach to all DynLayers or another class like this:
// DynLayer.prototype.glideTo = PathAnimation.glideTo;
// DynLayer.prototype.glideStop = PathAnimation.glideStop;

// These will invoke "pathstart", "pathrun", "pathfinish" and "pathcancel" events on the dynlayer

PathAnimation.slideTo = function(x,y,inc,ms) {
	if (!this._pathanim) this._pathanim = new PathAnimation(this);
	if (!ms) ms = 20;
	if (!inc) inc = 10;
	if (x==null) x = this.x;
	if (y==null) y = this.y;
	this._pathanim.sleep(ms);
	this._pathanim.play( SlideAnimation(this.x,this.y, x,y, inc) );
};
PathAnimation.slideStop = function () {
	if (this._pathanim) this._pathanim.stop();
};

// Generates a path between 2 points, stepping inc pixels at a time
function SlideAnimation(x1,y1,x2,y2,inc) {
	if (x2==null) x2 = x1;
	if (y2==null) y2 = y1;
	var distx = x2-x1;
	var disty = y2-y1;
	if (x1==x2 && y1==y2) return;
	var num = Math.sqrt(Math.pow(distx,2) + Math.pow(disty,2))/(inc||10)-1;
	var dx = distx/num;
	var dy = disty/num;
	var path = [];
	var x = x1;
	var y = y1;
	for (var i=0;i<=num;i++) {
		x += dx;
		y += dy;
		path[i*2] = Math.round(x);
		path[i*2+1] = Math.round(y);
	}
	if (path[i*2-2] != x2 || path[i*2-1] != y2) {
		path[i*2] = x2;
		path[i*2+1] = y2;
	}
	return path;
};
PathAnimation.line = SlideAnimation;

// a useful functions in some cases but not needed for slide

// Generates a path between 2 points in N steps
/*PathAnimation.lineN = function(x1,y1,x2,y2,N) {
	if (N==0) return [];
	var dx = (x2 == x1)? 0 : (x2 - x1)/N;
	var dy = (y2 == y1)? 0 : (y2 - y1)/N;
	var path = new Array();
	for (var i=0;i<=N;i++) {
		path[i*2] = Math.round(x1 + i*dx);
		path[i*2+1] = Math.round(y1 + i*dy);
	}
	return path;
};*/

