/*
	DynAPI Distribution
	Thread class

	The DynAPI Distribution is distributed under the terms of the GNU LGPL license.

	requires: dynapi.api.DynLayer
*/

function Thread(dlyr) {
	// Inherit from object. Provides unique ID
	this.inherit('DynObject');
	this.setDynLayer(dlyr);
}
var p = dynapi.setPrototype('Thread','DynObject');
p.active = false;
p.interval = 50;
p.cancelThread = false;
p.sleep = function (ms) {
	this.interval = Math.abs(parseInt(ms));
	if (this.active) {
		this.stop();
		setTimeout(this+'.start()',this.interval+1);
	}
};
p.setFPS = function (fps) {
	this.sleep(Math.floor(1000/fps));
};
p.cancel = function () {
	this.cancelThread = true;
	this.stop();
};
p.start = function () {
	if (!this.active) {
		this.active = true;
		if (!this.cancelThread) this.timer = setInterval(this+'.run()',this.interval);
	}
};
p.run = dynapi.functions.Null; // overwrite run
p.stop = function () {
	this.active = false;
	if (!this.cancelThread && this.timer) {
		clearInterval(this.timer);
		delete this.timer;
	}
};
p.setDynLayer = function (dlyr) {
	this.dlyr = dlyr;
};
p.getDynLayer = function () {
	return this.dlyr;
};
