/*
   DynAPI Distribution
   LoadPanel Class

   The DynAPI Distribution is distributed under the terms of the GNU LGPL license.

   Requirements:
	dynapi.api [dynlayer, dyndocument, browser, events]
*/

function LoadPanel(url) {
	this.DynLayer = DynLayer;
	this.DynLayer();

	this.autoH=true;
	this.autoW=false;
	this.isILayer=false;
	this.isIFrame=!(dynapi.ua.ie5 && is.platform=='win32');
	this._isReloading = false;
	
	this.addEventListener(LoadPanel.events);
	this.url = url;
};
LoadPanel.events = {
	oncreate : function(e) {
		var o = e.getSource();
		if (!o._isReloading) {
			o.setURL(o.url);
		}
	}
};
LoadPanel.prototype = new DynLayer();
LoadPanel.prototype._DynLayer_setSize = DynLayer.prototype.setSize;
LoadPanel.prototype.setSize = function(w,h) {
	var r = this._DynLayer_setSize(w,h);
	if (r && this._created && !this._isReloading && this.autoH && this.url) this.reload();
};
LoadPanel.prototype.setAutoResizeWidth=function(b) {this.autoW=b};
LoadPanel.prototype.setAutoResizeHeight=function(b) {this.autoH=b};
LoadPanel.prototype.useILayer=function(b) {
	if (dynapi.ua.ns4) {
		this.isILayer=b;
		if (this.created) this.reload();
	}
};
LoadPanel.prototype.useIFrame=function(b) {
	if (is.def) {
		this.isIFrame=b;
		if (this.created) this.reload();
	}
};
LoadPanel.prototype.insertInlineElements=function() {
	if (dynapi.ua.ie) {
		if (this.isIFrame) this.setHTML('<IFRAME ID="'+this.id+'loadElement" STYLE="visibility: hidden; display: none;"></IFRAME>',false);
		else this.setHTML('<DIV ID="'+this.id+'loadElement" STYLE="behavior:url(#default#download)" style="display: none;"></DIV>',false);
	}
	else if (dynapi.ua.ns4 && this.isILayer) this.setHTML('<ilayer></ilayer>',false);
	else if (dynapi.ua.ns6) this.setHTML('<IFRAME ID="'+this.id+'loadElement" STYLE="visibility: hidden;"></IFRAME>',false);
};
LoadPanel.prototype.findInlineElements=function() {
	if (dynapi.ua.ie) {
		if (this.isIFrame) this.loadElement=document.frames(this.id+'loadElement');
		else this.loadElement=document.all(this.id+'loadElement');
		alert(this.loadElement);
	}
	else if (dynapi.ua.ns4) {
		if (this.isILayer) this.loadElement=this.doc.layers[0];
		else this.loadElement=this.elm;
	}
	else if (dynapi.ua.ns6) this.loadElement=document.getElementById(this.id+'loadElement');
};
LoadPanel.prototype.getFileScope=function() {
	if (!this.loadElement) return null;
	return this.loadElement;
};
LoadPanel.prototype.clearFile=function() {
	this.url=null;
	if (this.isILayer) {
		this.loadElement.document.write('');
		this.loadElement.document.close();
	}
	else this.reload();
};
LoadPanel.prototype.getURL=function() {
	return this.url;
};
LoadPanel.prototype.setURL = function(url) {
	alert('yo')
	if (!url) return;
	else if (!this._created) this.url = url;
	else LoadPanel.queue.add(url,this);
};
LoadPanel.prototype.reload=function() {
	this._isReloading=true;
	this.setHTML('');
	this.setURL(this.url);
	this._isReloading=false;
};
LoadPanel.prototype.loadHandler=function(url) {
	this.url=url;
	if (dynapi.ua.ie5 && !this.isIFrame && this.elm && this.elm.all) {
		var imgs = this.elm.all.tags("img");
		for (var i=0;i<imgs.length;i++) {
			if (imgs[i].readyState == 'uninitialized') imgs[i].src = imgs[i].src;
		}
	}
	if (dynapi.ua.ns4 && this.isILayer) {
		var w = this.loadElement.document.width;
		var h = this.loadElement.document.height;
	}
	else {
		var w = this.getContentWidth()||this.w;
		var h = this.getContentHeight()||this.h;
	}
	this._DynLayer_setSize(this.autoW?w:null,this.autoH?h:null);
	this._isReloading=false;
	this.invokeEvent('load');
};
function LoadQueue() {
	this.queue=new Array();
	this.index=0;
};
LoadQueue.prototype.toString=function() {
	return "LoadPanel.queue";
};
LoadQueue.prototype.add=function(url,loadpanel) {
	var q=this.queue.length;
	this.queue[q]=[url,loadpanel];
	this.loadNext();
};
LoadQueue.prototype.loadNext=function() {
	dprint('loadnext')
	if (!this.busy && this.queue[this.index]) {
		this.busy=true;
		var lpanel=this.currentLoadPanel=this.queue[this.index][1];
		var url=this.currentURL=this.queue[this.index][0];
		if (dynapi.ua.ns4) {
			if (!lpanel.loadElement) {
				lpanel.insertInlineElements();
				lpanel.findInlineElements();
			}
			DynAPI.document.releaseMouseEvents();
			var lyr=lpanel.elm;
			while(lyr.parentLayer) lyr=lyr.parentLayer;
			lyr.onload=LoadQueue.loadHandler;
			lpanel.loadElement.onload=LoadQueue.loadHandler;
			lpanel.loadElement.src=url;
		} else {
			if (!lpanel.loadElement) {
				alert('no')
				lpanel.insertInlineElements();
				lpanel.findInlineElements();
			}
			if (dynapi.ua.ie) {
				if (lpanel.isIFrame) {
					lpanel.loadElement.document.isLoading=true;
					lpanel.loadElement.location=url;
					lpanel.timerID=setInterval(this.toString() + '.loadTimer()',250);
				}
				else lpanel.loadElement.startDownload(url,LoadQueue.loadHandler);
			}
			else if (dynapi.ua.ns6) {
				lpanel.timerID=setInterval(this.toString() + '.loadTimer()',250);
				lpanel.loadElement.src=url;
			}
		}
		Methods.removeFromArray(this.queue,this.index);
	}
};
if (dynapi.ua.ns6) {
	LoadQueue.prototype.loadTimer=function() {
		var lpanel=this.currentLoadPanel;
		if (!document.getElementById(lpanel.id+'loadElement')) {
			clearInterval(lpanel.timerID);
			LoadQueue.continueLoad();
		}
		else if (lpanel.loadElement.contentDocument && lpanel.loadElement.contentDocument.body.innerHTML != document.body.innerHTML) {
			clearInterval(lpanel.timerID);
			LoadQueue.loadHandler(lpanel.loadElement.contentDocument);
		}
	}
} else if (dynapi.ua.ie) {
	LoadQueue.prototype.loadTimer=function() {
		var lpanel=this.currentLoadPanel;
		if (!document.frames(lpanel.id+'loadElement')) {
			clearInterval(lpanel.timerID);
			LoadQueue.continueLoad();
		}
		else if (!lpanel.loadElement.document.isLoading && (lpanel.loadElement.document.readyState=='interactive' || lpanel.loadElement.document.readyState=='complete')) {
			clearInterval(lpanel.timerID);
			LoadQueue.loadHandler(lpanel.loadElement.document.body.innerHTML);
		}
	}
}
LoadQueue.loadHandler=function(e) {
	var q=LoadPanel.queue;
	var lp=q.currentLoadPanel;
	if (q.currentLoadPanel) {
		if (dynapi.ua.ie) {
			lp.elm.innerHTML=e;
			if (lp.isIFrame) lp.loadElement=null;
		}
		else if (dynapi.ua.ns4) {
			var lyr = lp.elm;
			while(lyr.parentLayer != window) lyr = lyr.parentLayer;
			lyr.onload = function(){};
			lp.loadElement.onload = function(){};
		}
		else if (dynapi.ua.ns6) {
			var html=e.body.innerHTML;
			lp.elm.innerHTML=html;
			lp.loadElement=null;
		}
		setTimeout('LoadQueue.continueLoad()',200);
	}
};
LoadQueue.continueLoad=function() {
	var q=LoadPanel.queue;
	q.currentLoadPanel.loadHandler(q.currentURL);
	q.busy=false;
	if (q.queue[q.index]) q.loadNext();
	else if (dynapi.ua.ns4) DynAPI.document.captureMouseEvents();
};
LoadPanel.queue=new LoadQueue();
